
/*
   Getatrom writes the AT ROM to a file of your choice.
   You can compile for a 80286 machine.
   This is for Turco C ver 2.0.
   01/20/90 modified by William M. Alford
*/

#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <string.h>

main(int argc, char *argv[])

{
FILE *outfile;
unsigned int c;
long rom_size;
unsigned char far *starting_address;
char filename[MAXPATH];
char copywrite[]="\nGetATRom, TC 2.0 Edition, (C) Modified by William M. Alford\n";

/* starting address of AT ROM in seg:offset format */
starting_address = ( char far *) 0xF0000000;        /* F000:0000 */

/* size of AT ROM */
rom_size = 0x10000;	/* 64K bytes */

printf("%s", copywrite);

if ( argc < 2 )
	{
	printf("\nUsage: getatrom filename.ext\n");
	return(0);
	}
strcpy ( filename, argv[1] );

/* open the file in binary mode! */
if (( outfile = fopen( filename,"wb" )) == NULL )
        {
	printf("\nCannot open output file: %s, aborting!\n", strupr(filename));
        return(1);
        }
while ( rom_size > 0 )
        {
	c = *starting_address;
        putc(c,outfile);
        *starting_address++;
	rom_size--;
	}
printf("\nSuccess, your new file %s is now on disk\n", strupr(filename));
fclose(outfile);
exit(0);
}
