/*
   Getxtrom writes the XT ROM to a file of your choice.
   >>>MUST<<< be compliled with the large model option.
   This is for Turco C ver 2.0.
   01/20/90 modified by William M. Alford
*/

#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <string.h>

main(int argc, char *argv[])

{
FILE *outfile;
unsigned int c;
long rom_size;
unsigned char far *starting_address;
char filename[MAXPATH];
char copywrite[]="\nGetXTRom, TC 2.0 Edition, (C) Modified by William M. Alford\n";

/* starting address of XT ROM in seg:offset format */
starting_address = (char far *) 0xF000E000; /* for 8K ROMS F000:E000 */
/* starting_address = 0xF000C000;             for 16K ROMS F000:C000 */
/* starting_address = 0xF000A000;             for 32K ROMS F000:A000 */
/* starting_address = 0xF0000000;             for 64K ROMS F000:0000 */

/* size of XT ROM */
rom_size = 0x2000;    /* for 8K ROMS  2764  */
/*  rom_size = 0x4000;  for 16K ROMS  27128 */
/*  rom_size = 0x8000;  for 32K ROMS  27256 */
/* rom_size = 0x10000;  for 64K ROMS  ????? */

printf("%s", copywrite);

if ( argc < 2 )
        {
        printf("\nUsage: getatrom filename.ext\n");
        return(0);
        }
strcpy ( filename, argv[1] );

/* open the file in binary mode! */
if (( outfile = fopen( filename,"wb" )) == NULL )
        {
        printf("\nCannot open output file: %s, aborting!\n", strupr(filename));
        return(1);
        }
while ( rom_size > 0 )
        {
        c = *starting_address;
        putc(c,outfile);
        *starting_address++;
        rom_size--;
        }
printf("\nSuccess, your new file %s is now on disk\n", strupr(filename));
fclose(outfile);
exit(0);
}
