/* This program is designed to londitudinally split files.
   It expects two arguments, the first argument specifies
   the maximum length of the target files, and the second
   the name of the source file.
   The target files are named F0 -  Fn.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

main(int argc, char *argv[])

{
int i, c, x;
char fp[6];
FILE *outfile, *infile;
if ( argc != 3)
	{
	printf("\nUseage LSplit <length of target file> <sourcefilename>\n");
	exit(0);
	}

/* get the maximum target file size */
i = atoi(argv[1]);

/* get the source filename*/
if ((infile = fopen(argv[2], "rb")) == NULL)
	{
	printf("\nCan't open input file %s\n", strupr(argv[2] ));
	exit(0);
	}

fp[0] = 'F';
fp[1] = 'I';
fp[2] = 'L';
fp[3] = 'E';
fp[5] = 0;
c = 0;

for ((fp[4] = '0'); (((c = getc(infile)) != EOF) && (fp[4] <= '9')); fp[4]++)
	{
	x = 2;
	outfile = fopen(fp, "wb");
	putc(c, outfile);
	while ((x <= i) && ((c = getc(infile)) != EOF))
		{
		putc(c,outfile);
		x++;
		}
	fclose(outfile);
	}

fclose(infile);

if (fp[4] > '9')
	{
	printf("\nWarning - 10 files were made, but more than this is required.");
	printf("\nPlease check your required file size carefully!\n");
	exit(1);
	}
printf ("\n%c files were made.\n", fp[4]);
exit(0);
}
